//////////////////////////////////////////////////////////////////////////////
//																			//
//	COPYRIGHT (c) 1998-99, Juan Franklin Pea.  All rights reserved.		//
//	email: bitwise@msn.com													//
//	The C++ Exchange:	http://www.geocities.com/SiliconValley/3341			//
//	This code is provided "as is" without express or implied warranty.		// 
//	Use it at your own risk! The author accepts no liability for any		//
//	damage or loss of business that any of this source code may cause.		//
//																			//
//	This source code may be used in compiled form in any way you desire.	// 
//	Source file(s) may be redistributed unmodified by any means PROVIDING	// 
//	they are not sold for profit without the authors expressed written		// 
//	consent, and providing that this notice and the authors name and all	// 
//	copyright notices remain intact. If the source code is used in any		// 
//	commercial applications then a statement along the lines of				// 
//	"Portions Copyright  1998-99 Juan Franklin Pea" must be included		// 
//	in the startup banner, "About" box or printed documentation. An email	// 
//	letting me know that you are using it would be appreciated.				// 
//	If you find any bugs, please send me an email describing the problem.	//
//																			//
//////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "OpenFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// COpenFileDlg dialog

COpenFileDlg::COpenFileDlg(CString directory
								, CString fileType
								, int	  iconId
								, BOOL	  bOpenDlg /*= TRUE*/
								, CWnd*   pParent  /*= NULL*/ )
	: CDialog(COpenFileDlg::IDD, pParent)
	, m_strDir(directory)
	, m_strFileType(fileType)
	, m_nIconId(iconId)
	, m_bIsOpenFileDlg(bOpenDlg)
	, m_strFileName("")
{
	//{{AFX_DATA_INIT(COpenFileDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COpenFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenFileDlg)
	DDX_Control(pDX, IDC_EDIT_FILENAME, m_ctrlFileName);
	DDX_Control(pDX, IDC_LIST_REQUESTED_FILES, m_ctrlRequestedFiles);
	DDX_Control(pDX, IDC_LIST_FILES, m_ctrlFiles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COpenFileDlg, CDialog)
	//{{AFX_MSG_MAP(COpenFileDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_REQUESTED_FILES, OnDblclkRequestedFiles)
	ON_EN_UPDATE(IDC_EDIT_FILENAME, OnUpdateEditFilename)
	ON_NOTIFY(NM_CLICK, IDC_LIST_REQUESTED_FILES, OnClickRequestedFiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenFileDlg message handlers

BOOL COpenFileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CWnd* pWnd;
	CString strWndTitle;

	if (!m_bIsOpenFileDlg)
	{
		strWndTitle.LoadString(_T(IDS_SAVE_FILE_AS));
		SetWindowText(strWndTitle);
		SetDlgItemText(IDOK, "Save");
	}
	else
	{
		strWndTitle.LoadString(_T(IDS_OPEN_FILE));
		SetWindowText(strWndTitle);
	}

	pWnd = GetDlgItem(IDOK);
	pWnd->EnableWindow(FALSE);

	CFileFind fileFind;

	// If directory does not exist, do not waste time
	if (!fileFind.FindFile(m_strDir))
	{
		CString msg("");
		msg.Format("Directory %s does not exist", m_strDir);
		MessageBox(msg, "Custom Open File Dialog", MB_OK | MB_ICONWARNING); 
		CDialog::OnCancel();
	}
	
	CString pathAndFileType = m_strDir + "\\*." + m_strFileType;
	m_ctrlFiles.Dir(DDL_DIRECTORY, pathAndFileType);

	int rowCount = m_ctrlFiles.GetCount();
	int row = m_ctrlFiles.GetTopIndex();


	m_IconImage.Create(::GetSystemMetrics(SM_CXICON) / 2,
					   ::GetSystemMetrics(SM_CYICON) / 2, TRUE, 10, 10);

	m_IconImage.Add( AfxGetApp()->LoadIcon(m_nIconId) );
	m_ctrlRequestedFiles.SetImageList(&m_IconImage, LVSIL_SMALL);

	LV_ITEM item;   // Create the list items
	item.mask = LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM;
	item.state = item.stateMask = 0;
	
	// Iterate through the items in the listbox and populate the listconrol.
	CString strBuffer;
	for (row; row < rowCount; row++)
	{
		item.iItem = row; 
		item.iSubItem = 0; // refers to item therefore  = 0

		m_ctrlFiles.GetText(row, strBuffer);

		item.pszText = (char*) (LPCTSTR) strBuffer;
		item.iImage  = 0;

		item.lParam = row;
		m_ctrlRequestedFiles.InsertItem(&item);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COpenFileDlg::OnOK() 
{
	int index = m_ctrlRequestedFiles.GetNextItem(-1, LVNI_SELECTED);

	if (index > -1)
	{
		m_strFileName = m_ctrlRequestedFiles.GetItemText(index, 0);
	}
	else
	{
		m_ctrlFileName.GetWindowText(m_strFileName);

		CString strExt = "." + m_strFileType;

		if (!m_strFileName.IsEmpty())
		{
			int nFoundExt = m_strFileName.Find(strExt);

			if (nFoundExt < 0)
			{
				m_strFileName += strExt;
			}
		}
	}

	CDialog::OnOK();
}

void COpenFileDlg::OnClickRequestedFiles(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int index = m_ctrlRequestedFiles.GetNextItem(-1, LVNI_SELECTED);

	if (index > -1)
	{
		m_strFileName = m_ctrlRequestedFiles.GetItemText(index, 0);

		m_ctrlFileName.SetWindowText(m_strFileName);
	}
	else
	{
		m_ctrlFileName.GetWindowText(m_strFileName);
		
		if ( m_strFileName.IsEmpty() )
		{
			CWnd* pWnd = GetDlgItem(IDOK);
			pWnd->EnableWindow(FALSE);
		}
	}
	
	*pResult = 0;
}

void COpenFileDlg::OnDblclkRequestedFiles(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int index = m_ctrlRequestedFiles.GetNextItem(-1, LVNI_SELECTED);

	if (index > -1)
	{
		m_strFileName = m_ctrlRequestedFiles.GetItemText(index, 0);
	}

	CDialog::OnOK();

	*pResult = 0;
}

void COpenFileDlg::OnUpdateEditFilename() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.

	m_ctrlFileName.GetWindowText(m_strFileName);
		
	if ( m_strFileName.IsEmpty() )
	{
		CWnd* pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(TRUE);
	}
}

CString COpenFileDlg::GetFileName()
{
	return m_strFileName;
}

CString COpenFileDlg::GetFilePath()
{
	return m_strDir + "\\" + m_strFileName;
}
